Bug 1212148 - Review Request: python-pyeclib - Python interface to erasure codes
Summary: Review Request: python-pyeclib - Python interface to erasure codes
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Haïkel Guémar
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: AcceptedFreezeException
Keywords:
Depends On: 1208695
Blocks: F23FinalFreezeException 1212670
TreeView+ depends on / blocked
 
Reported: 2015-04-15 16:14 UTC by Pete Zaitcev
Modified: 2015-10-19 21:08 UTC (History)
10 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2015-10-19 21:08:53 UTC
karlthered: fedora-review+


Attachments (Terms of Use)
pyeclib-1.0.7 from SRPM vs PyECLib-1.0.7 from PyPI (21.07 KB, text/plain)
2015-04-17 10:07 UTC, Alan Pevec
no flags Details

Description Pete Zaitcev 2015-04-15 16:14:32 UTC
Spec URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.6-1.spec
SRPM URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.6-1.fc21.src.rpm
Description:
This library provides a simple Python interface for implementing erasure
codes. A number of back-end implementation is supported either directly
or through the C interface liberasurecode.

Fedora Account System Username: zaitcev

Comment 1 Pete Zaitcev 2015-04-15 16:19:11 UTC
Reviewers - I suspect there are issues with this package. This review is
posted at this early stage in order to anchor the packaging effort.
Without PyECLib, Swift (openstack-swift) cannot be built or even unit-tested
in F23.

See also the packages required by PyECLib:
 bug 1094570: gf-complete
 bug 1095012: jerasure
 bug 1208695: liberasurecode

See also the tracker for EC in Swift in RDO/RHEL OSP:
 bug 1041510

Comment 2 Pete Zaitcev 2015-04-16 04:09:16 UTC
Spec URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.7-1.spec
SRPM URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.7-1.fc21.src.rpm
Description:
This library provides a simple Python interface for implementing erasure
codes. A number of back-end implementation is supported either directly
or through the C interface liberasurecode.

Fedora Account System Username: zaitcev

Comment 3 Haïkel Guémar 2015-04-17 08:48:52 UTC
1. use %{__python2} and %{__python2_sitelib} instead of %{__python}/%{__python_sitelib} as we're switching to python3, it could be confusing.

2. use %{__python2_sitearch} instead of %{_libdir}/python2*/site-packages/*  (the same for python3}

3. drop the commented BuilArch field, not needed.

Comment 4 Alan Pevec 2015-04-17 09:48:57 UTC
Please make python3 conditional so it can be built for EL7 which doesn't have python3 available:

%if 0%{?fedora}
%global with_python3 1
%endif

and wrap each python3 specific part of spec in
%if 0%{?with_python3}
...
%endif

e.g. http://pkgs.fedoraproject.org/cgit/python-oslo-config.git/commit/?id=49e0694d3d0746010ae060ec3fde8358eae020a8

Comment 5 Alan Pevec 2015-04-17 10:00:12 UTC
> # Bitbucket's naming is like the old github (== awful), so we pull
> # the tag using git CLI. Save the current command for Source0 below.
> #  git archive -o ../pyeclib-1.0.7.tar.gz --prefix=pyeclib-1.0.7/ v1.0.7m
> # N.B.: That '-m' suffix is temporary. Tushar says that tags without
> # the '-m' include liberasurecode, so that Jenkins can work. Pure magic.
> Source0:        pyeclib-%{version}.tar.gz

What's wrong with https://pypi.python.org/packages/source/P/PyECLib/PyECLib-1.0.7.tar.gz ?

Comment 6 Alan Pevec 2015-04-17 10:07:06 UTC
Created attachment 1015512 [details]
pyeclib-1.0.7 from SRPM vs PyECLib-1.0.7 from PyPI

Attaching diff between tarball in SRPM vs tarball from PyPI

Comment 7 Alan Pevec 2015-04-17 11:41:26 UTC
> See also the packages required by PyECLib:
>  bug 1094570: gf-complete
>  bug 1095012: jerasure

Those two are blocked on legal issues, are they really required?

Comment 8 Alan Pevec 2015-04-17 12:00:10 UTC
They are:
ec_driver = ECDriver(k=1, m=1, ec_type='jerasure_rs_vand')
liberasurecode[27246]: liberasurecode_backend_open: dynamic linking error libJerasure.so: cannot open shared object file: No such file or directory

Pete, what is tl;dr for legal issues?

Comment 9 Pete Zaitcev 2015-04-17 14:11:16 UTC
(In reply to Alan Pevec from comment #7)
> Those two are blocked on legal issues, are they really required?

In a specific site, one could use alternatives supported by liberasurecode,
such as the Intel's library. The alternatives switching is the sole reason
why liberasurecode exists. But we cannot use that one in Fedora, because
it's specific to Intel CPUs. The GF-complete/Jerasure combo is what everyone
uses upstream.

> What's wrong with https://pypi.python.org/packages/source/P/PyECLib/PyECLib-1.0.7.tar.gz ?

If you're okay with PyPI, I can switch to there. I seem to recall that
it was nearly impossible to extract old tarballs from there though.

Comment 10 Alan Pevec 2015-04-17 15:04:23 UTC
Need to add BuildRequires: python-setuptools
otherwise
  File "setup.py", line 39, in <module>
    from distribute_setup import use_setuptools
ImportError: No module named distribute_setup

Comment 11 Pete Zaitcev 2015-04-22 04:04:04 UTC
(In reply to Alan Pevec from comment #4)
> Please make python3 conditional so it can be built for EL7 which doesn't
> have python3 available:
> 
> %if 0%{?fedora}
> %global with_python3 1
> %endif
> 
> and wrap each python3 specific part of spec in
> %if 0%{?with_python3}
> ...
> %endif

This is a horrible idea that we purged from Fedora previously
at every turn. We have separate branches in git for that and there's
no need to or excuse to pollute the spec with these conditionals.
When the time to backport comes, I'll remove the references to python3.

Comment 12 Pete Zaitcev 2015-04-22 04:31:37 UTC
Spec URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.7-2.spec
SRPM URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.7-2.fc21.src.rpm
Description:
This library provides a simple Python interface for implementing erasure
codes. A number of back-end implementations is supported either directly
or through the C interface liberasurecode.

Fedora Account System Username: zaitcev

Most comments are addressed, except:
 - No conditionals for RHEL 7, to be implemented when needed
 - No %{__python2_sitelib}, in order to support F21
   (directly contradicts the previous omission, of course...)

I'll do the proper mocking and Rawhide builds when I get around to it,
most likely for 1.0.8.

Comment 13 Haïkel Guémar 2015-04-23 13:01:31 UTC
My mistake, it's %{python2_sitearch}  

As for the python3 conditional, we will need to rebuild this package on CentOS build system for RDO and to keep things consistent we prefer reusing fedora sources. At least consider, requesting an EPEL7 branch (the same goes for liberasurecode)

AFAIK, packaging is good, now waiting for liberasurecode review.

Comment 14 Alan Pevec 2015-05-02 01:36:21 UTC
> Most comments are addressed, except:
>  - No conditionals for RHEL 7, to be implemented when needed

It is needed yesterday, I'm now using draft spec for CentOS CloudSIG builds.

While conditionals might not look nice, it's one-time cost to add them and then you get free merges across all branches i.e. keep same spec for all targets.
If you fork spec in epel7 to remove py3 stuff, you'll have conflicts on each update.

Comment 15 Haïkel Guémar 2015-10-07 07:48:48 UTC
since liberasurecode was approved, could we refresh the spec and finish this review?
EL7 conditionals would be appreciated so that we keep the same spec in CentOS Cloud SIG.

Comment 16 Kalev Lember 2015-10-09 12:48:35 UTC
What's the issue blocking the review here? Would be nice to get this in before the F23 final freeze so that openstack-swift doesn't get dropped from Fedora due to broken deps.

I mean, there's definitely some cleanup to do, but that shouldn't block the review. If licensing is fine and the naming is fine and the spec file isn't completely crazy, it should be fine to approve this. It's much easier to incrementally improve this once it's in git where people can collaborate.

I can't see why RHEL 7 support has to block Fedora inclusion, for example.

If licensing and naming and other things that are difficult to fix look fine, I'd probably just approve the review as it is.

Comment 17 Upstream Release Monitoring 2015-10-12 07:07:49 UTC
zaitcev's scratch build of python-pyeclib-1.0.9-1.fc22.src.rpm for f24-candidate completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11411775

Comment 18 Pete Zaitcev 2015-10-12 07:26:09 UTC
Spec URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.9-1.spec
SRPM URL: http://people.redhat.com/zaitcev/tmp/python-pyeclib-1.0.9-1.fc22.src.rpm
Description:
This library provides a simple Python interface for implementing erasure
codes. A number of back-end implementations is supported either directly
or through the C interface liberasurecode.

Fedora Account System Username: zaitcev

Added conditionals (stolen from python-pbr) and tested on f24.
The upstream update works without my patch, so dropped %patch-ing
[ noticed in the last second that I only commented it out, not
removed outright ]

Comment 19 Haïkel Guémar 2015-10-13 14:41:37 UTC
One small oversight:
python-pyeclib.x86_64: E: non-standard-executable-perm /usr/lib64/python2.7/site-packages/pyeclib_c.so 775

Could you fix the permission before import?

I hereby approve this package into Fedora Packages Collection



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause)". Detailed output of licensecheck in
     /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-
     pyeclib-1.0.9-1/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-pyeclib , python-pyeclib-debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.2.13 starting (python version = 3.4.3)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled ccache
Mock Version: 1.2.13
INFO: Mock Version: 1.2.13
Finish: chroot init
INFO: installing package(s): /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python-pyeclib-1.0.9-1.fc24.x86_64.rpm /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python3-pyeclib-1.0.9-1.fc24.x86_64.rpm /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python-pyeclib-debuginfo-1.0.9-1.fc24.x86_64.rpm /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python-pyeclib-debuginfo-1.0.9-1.fc24.x86_64.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 24 install /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python-pyeclib-1.0.9-1.fc24.x86_64.rpm /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python3-pyeclib-1.0.9-1.fc24.x86_64.rpm /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python-pyeclib-debuginfo-1.0.9-1.fc24.x86_64.rpm /home/haikel/1212148-python-pyeclib-1.0.7-2/1212148-python-pyeclib-1.0.9-1/results/python-pyeclib-debuginfo-1.0.9-1.fc24.x86_64.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: python-pyeclib-1.0.9-1.fc24.x86_64.rpm
          python3-pyeclib-1.0.9-1.fc24.x86_64.rpm
          python-pyeclib-debuginfo-1.0.9-1.fc24.x86_64.rpm
          python-pyeclib-1.0.9-1.fc24.src.rpm
python-pyeclib.x86_64: E: non-standard-executable-perm /usr/lib64/python2.7/site-packages/pyeclib_c.so 775
python-pyeclib.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/python-pyeclib/README
python3-pyeclib.x86_64: W: spelling-error %description -l en_US liberasurecode -> deliberateness
python3-pyeclib.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/python3-pyeclib/README
python3-pyeclib.x86_64: E: non-standard-executable-perm /usr/lib64/python3.4/site-packages/pyeclib_c.cpython-34m.so 775
python-pyeclib.src: W: spelling-error %description -l en_US liberasurecode -> deliberateness
python-pyeclib.src: W: invalid-url Source0: pyeclib-1.0.9.tar.gz
4 packages and 0 specfiles checked; 2 errors, 5 warnings.




Requires
--------
python-pyeclib-debuginfo (rpmlib, GLIBC filtered):

python-pyeclib (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    liberasurecode
    liberasurecode.so.1()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)

python3-pyeclib (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    liberasurecode.so.1()(64bit)
    libpthread.so.0()(64bit)
    libpython3.4m.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)



Provides
--------
python-pyeclib-debuginfo:
    python-pyeclib-debuginfo
    python-pyeclib-debuginfo(x86-64)

python-pyeclib:
    python-pyeclib
    python-pyeclib(x86-64)

python3-pyeclib:
    python3-pyeclib
    python3-pyeclib(x86-64)



Unversioned so-files
--------------------
python-pyeclib: /usr/lib64/python2.7/site-packages/pyeclib_c.so
python3-pyeclib: /usr/lib64/python3.4/site-packages/pyeclib_c.cpython-34m.so

Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1212148 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 20 Haïkel Guémar 2015-10-13 18:28:50 UTC
As we're short on time (required to keep openstack-swift on F23), I submitted the new package request through packageDB, I will add Pete as PoC as soon as the package is created.

Comment 21 Pete Zaitcev 2015-10-14 14:19:33 UTC
Aww, it appears I only ran rpmlint against the SRPM. Will fix.

Comment 22 Kalev Lember 2015-10-15 07:25:00 UTC
Looks like the repos got created, https://admin.fedoraproject.org/pkgdb/package/python-pyeclib/

Comment 23 Kalev Lember 2015-10-15 07:28:51 UTC
Proposing as a Freeze Exception.

For past three releases we have had a goal to have no broken dependencies in Fedora base repos. openstack-swift is one of the two remaining packages with broken deps; the new python-pyeclib package satisfies that broken dependency. Would be great to pull this in through the freeze as a Freeze Exception to avoid getting openstack-swift dropped from Fedora.

Comment 24 Kevin Fenzi 2015-10-15 19:28:48 UTC
+1 FE

Comment 25 Fedora Update System 2015-10-15 19:49:25 UTC
python-pyeclib-1.0.9-1.fc23 liberasurecode-1.0.9-3.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-9fa214a26f

Comment 26 Adam Williamson 2015-10-15 21:24:57 UTC
Discussed at 2015-10-15 freeze exception review meeting: https://meetbot-raw.fedoraproject.org/fedora-blocker-review/2015-10-15/f23-blocker-review.2015-10-15-20.11.log.txt . In principle we generally approved this kind of FE, as avoiding dependency problems in the frozen trees is a useful goal, and there's no apparent complications with this one, so it's approved.

Comment 27 Fedora Update System 2015-10-16 03:02:50 UTC
liberasurecode-1.0.9-3.fc23, python-pyeclib-1.0.9-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update python-pyeclib liberasurecode'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-9fa214a26f

Comment 28 Fedora Update System 2015-10-19 21:08:50 UTC
liberasurecode-1.0.9-3.fc23, python-pyeclib-1.0.9-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.